if ?__h17_rom_inc__ == 0
__h17_rom_inc__: equ 1

; some sort of entry points in another ROM...
h17_abort_d:	equ	01bf6h	; abort any active disk I/O
h17_clock_d:	equ	01c19h	; clock intr routine
h17_read_d:	equ	01c3fh	; read sectors
h17_sdp_d:	equ	01e32h	; set disk params
h17_whd_d:	equ	01e9dh	; wait hole detect
h17_wnh_d:	equ	01eb9h	; wait no hole

h17_block_src:	equ	01f5ah

		org	2000h
mem_start:	defs	0
l2000h:		defs	3
l2003h:		defs	1
l2004h:		defs	1
		defs	3
saved_z17p3:	defs	1	; 2008
saved_h8fp:	defs	1
		defs	17
tic_ctr:	defs	2
start_sp:	defs	2

; jump vectors/hooks...
rst_vecs:
rst08_vec:	defs	3	; 7x JMP's... @ l201fh
rst10_vec:	defs	3
rst18_vec:	defs	3
rst20_vec:	defs	3
rst28_vec:	defs	3
rst30_vec:	defs	3
rst38_vec:	defs	3

boot_dev:	defs	2
saved_gp:	defs	1
z37_ret:	defs	2	; routine to terminate z37 interrupt
		defs	5
l203eh:		defs	2
l2040h:		defs	8

h17_block_dest:
h17_xita:		defs	2	; XITA	
h17_writa:		defs	1	; WRITA
h17_writb:		defs	1	; WRITB
h17_writc:		defs	1	; WRITC
h17_maia:		defs	1	; MAIA
h17_lpsa:		defs	1	; LPSA
h17_sdpa:		defs	1	; SDPA
h17_sdpb:		defs	1	; SDPB
h17_stsa:		defs	1	; STSA
h17_stsb:		defs	1	; STSB
h17_whda:		defs	1	; WHDA	; wait hole detect
h17_wnha:		defs	1	; WNHA	; wait no hole
h17_wsca:		defs	1	; WSCA
h17_erts:		defs	2	; INC (HL); RET ; ERTS - trk/sec of last error
h17_sydd:		defs	3	; SYDD - sys disk device driver, A=func
					;	A=0: read
					;	A=1: write
					;	A=2: readr
					;	A=7: abort
					;	A=?: mount
h17_mount:		defs	3	; MOUNT - mount new media, L=volid
h17_xok:		defs	3	; XOK	- exit with all OK
h17_abort:		defs	3	; ABORT	- abort any active I/O
h17_xit:		defs	3	; XIT	- exit A=status
h17_read:		defs	3	; READ	- BC=count, DE=mem, HL=block
h17_readr:		defs	3	; READR	- read, ignore vol prot
h17_write:		defs	3	; WRITE	- BC=count, DE=mem, HL=block
h17_cde:		defs	3	; CDE	- count disk errors
h17_dts:		defs	3	; DTS	- decode trk/sec HL=sec-idx
h17_sdt:		defs	3	; SDT	- seek desired trk
h17_mai:		defs	3	; MAI	- mv arm in - step in
h17_mao:		defs	3	; MAO	- mv arm out - step out
h17_lps:		defs	3	; LPS	- locate proper sec
h17_rdb:		defs	3	; RDB	- read disk byte - D=cksum (in/out)
h17_sdp:		defs	3	; SDP	- set dev parms
h17_sts:		defs	3	; STS	- skip this sector
h17_stz:		defs	3	; STZ	- seek trk 0
h17_udly:		defs	3	; UDLY	- A=loop count (may be used w/DI)
h17_wsc:		defs	3	; WSC	- wait sync char
h17_wsp:		defs	3	; WSP	- write sync pattern
h17_wnb:		defs	3	; WNB	- write next byte
h17_errt:		defs	3	; ERRT	- error test loop
h17_dly:		defs	3	; DLY	- A=msec/2
h17_block_len:	equ	$-h17_block_dest

h17_zero_init:
l20a0h:		defs	1	; tt - target trk
l20a1h:		defs	1	; ts - targ sector
l20a2h:		defs	1	; dvctl - device ctl
l20a3h:		defs	1	; dlymo - motor-on delay count
l20a4h:		defs	1	; dlyhs	- head settle delay
l20a5h:		defs	2	; trkpt - adr trk in drvtb
l20a7h:		defs	2	; volpt - adr vol in drvtb
l20a9h:		defs	8	; drvtb: trk/vol for 4 drives
		defs	1	; hecnt - hard error count
l20b2h:		defs	2	; secnt - soft error count
h17_oecnt:	defs	1	; oecnt - operation error
; err block:
l20b5h:		defs	2	; mds/hsy - missing data sync, header sync
l20b7h:		defs	6	; chk/hck/vol/trk/opr
l20bdh:		defs	2	; opw
h17_zero_len:	equ	$-h17_zero_init

; Other uses of memory...
		defs	9	; date in ascii
		defs	2	; coded date
		defs	4	; tics since midnight
		defs	2	; h/w hi mem adr
l20d0h:		defs	2	; fwa res sys
l20d2h:		defs	2	; lwa usr mem
		defs	12+16	; max overlay size, ...
l20f0h:		defs	1
l20f1h:		defs	1
l20f2h:		defs	2
l20f4h:		defs	2
l20f6h:		defs	2
l20f8h:		defs	1
l20f9h:		defs	1
l20fah:		defs	2
l20fch:		defs	2
l20feh:		defs	2
l2100h:		defs	2
l2102h:		defs	2
l2104h:		defs	2
		defs	5
l210bh:		defs	16+9
l2124h:		defs	1
l2125h:		defs	1
l2126h:		defs	1
l2127h:		defs	1
l2128h:		defs	1
l2129h:		defs	2
		defs	6
boot_unit:	defs	1
z67_cmd_buf:	defs	6	; <cmd>, <unit>, <0>, <0>, <0>, <0>
				; <8>, <unit>, <0>, <0>, <10>, <128> = read?
z67_res_buf:	defs	7
l213fh:		defs	1
		defs	9
l2149h:		defs	1
		defs	1
l214bh:		defs	1
l214ch:		defs	2
		defs	2
boot_base_port:	defs	2	; 2150...
boot_time:	defs	1	; number of 512-tic intervals
auto_disable:	defs	1	; 080h = disable auto boot

		defs	44
		defs	256
boot_stack:			; must be 02280h!
boot_loc:	defs	0	; must be 02280h!

	seek	0
endif
